/* 
  - RUTA: /gridContent
  - BOTON PARRILLA
  - SOLO MUESTRA LOS DIAS DE LA SEMANA Y LOS ESTADOS DE: INICIO ... SEÑALES
  - ESTA INCOMPLETO
*/
<template>
  <div>
    <!-- Cuerpo -->
    <div class="padding-top margin-0-4">
      <el-header style="height: auto !important" class="padding-0">
        <ReturnButton :spanTitle="2" title="Regresar" style="margin-bottom: 35px;" @clickEvent="returnPage"></ReturnButton>
        <!-- Buscador -->
        <el-row>
         <el-col :span="4" :offset="10">
            <el-input 
              placeholder="Código"
              prefix-icon="el-icon-search"
              v-model="codeSearch"
              @keyup.enter.native="findCodeProgram" 
              clearable>
            </el-input>
           </el-col>
            <el-col :span="9"  :offset="1">
              <el-autocomplete
                v-model="textSearch"
                style="width: 100%;"
                :fetch-suggestions="querySearch" 
                placeholder="Nombre del programa" 
                :trigger-on-focus="false"
                @select="handleSelect">
                  <i 
                    class="el-icon-search el-input__icon"
                    slot="prefix">
                  </i>
                <template slot-scope="props">
                  <div>{{ props.item.programTitle }}</div>
                </template>
              </el-autocomplete>
            </el-col> 
        

          <!-- <el-col :span="8" :offset="16">
            <el-autocomplete
              v-model="textSearch"
              style="width: 100%;"
              :fetch-suggestions="querySearch" 
              placeholder="Buscar programa" 
              :trigger-on-focus="false"
              @select="handleSelect">
                <i 
                  class="el-icon-search el-input__icon"
                  slot="prefix">
                </i>
              <template slot-scope="props">
                <div>{{ props.item.programTitle }}</div>
              </template>
            </el-autocomplete>
          </el-col> -->
        </el-row>
        <!-- Título del programa -->
        <el-col :span="24">
          <div class="titleSection">PROGRAMACIÓN {{typeChannel}} - {{ programObj.programTitle }} ({{programObj.codProgram}})</div>
        </el-col>
        <!-- Fecha y botones -->
        <el-row>
          <el-col :span="7">
            <p style="margin-top: 0.6rem;">{{ dateString }} </p>
          </el-col>
          <el-col :span="7">
            <el-date-picker
              class="date-head"
              v-model="dateSearch"
              type="date"
              format="dd/MM/yyyy"
              value-format="timestamp"
              placeholder="Escoja una semana"
              @input="setWeek">
            </el-date-picker>
          </el-col>
          
          <el-col :span="6" class="text-end">
            <el-button v-on:click="programObjectInfo('editCuts', objGridInfo)" class="text-orange border-orange" plain :disabled="isShowEditCut()">EDITAR CORTES</el-button>
          </el-col>
          <el-col :span="4" class="text-end">
            <!--  -->
            <el-button v-on:click="programObjectInfo('programGrid', objGridInfo)" type="primary" :disabled="noEsVigente">PROGRAMAR</el-button>
          </el-col>
        </el-row>
      </el-header>
      <el-main style="padding: 0;">
        <br>
        <div class="scheduleProgramming">
          <div class="scheduleDay-border" style="height: 100%;"></div>
          <div class="scheduleDay scheduleDay-border"> Lunes <span class="textCollapse"> {{addingZerosToTheDay(firstDay)}}</span> </div>
          <div class="scheduleDay scheduleDay-border"> Martes <span class="textCollapse"> {{addingZerosToTheDay(secondDay)}} </span> </div>
          <div class="scheduleDay scheduleDay-border"> Miércoles <span class="textCollapse"> {{addingZerosToTheDay(thirdDay)}} </span> </div>
          <div class="scheduleDay scheduleDay-border"> Jueves <span class="textCollapse"> {{addingZerosToTheDay(fourthDay)}} </span> </div>
          <div class="scheduleDay scheduleDay-border"> Viernes <span class="textCollapse"> {{addingZerosToTheDay(fifthDay)}} </span> </div>
          <div class="scheduleDay scheduleDay-border"> Sábado <span class="textCollapse"> {{addingZerosToTheDay(sixthDay)}} </span> </div>
          <div class="scheduleDay"> Domingo <span class="textCollapse"> {{addingZerosToTheDay(lastDay)}} </span> </div>
        </div>

        <div class="scheduleData" ref="scheduleData">
          <div style="grid-area: 1 / span 1" class="columColor scheduleCellData__border-bottom schedule__border-right scheduleCellData__border-top">Inicio</div>
          <div style="grid-area: 2 / span 1" class="columColor scheduleCellData__border-bottom schedule__border-right scheduleCellData__border-top">Final</div>
          <div style="grid-area: 3 / span 1" class="columColor scheduleCellData__border-bottom schedule__border-right scheduleCellData__border-top">Material</div>
          <div style="grid-area: 4 / span 1" class="columColor scheduleCellData__border-bottom schedule__border-right scheduleCellData__border-top">Capítulo</div>
          <div style="grid-area: 5 / span 1" class="columColor scheduleCellData__border-bottom schedule__border-right scheduleCellData__border-top">Estado</div>
          <!-- <div v-if="false" style="grid-area: 6 / span 1" class="columColor scheduleCellData__border-bottom schedule__border-right scheduleCellData__border-top"> DURACION </div> -->
          <div style="grid-area: 6 / span 1" class="columColor scheduleCellData__border-bottom schedule__border-right scheduleCellData__border-top">N° de Cortes</div>
          <div style="grid-area: 7 / span 1" class="columColor scheduleCellData__border-bottom schedule__border-right scheduleCellData__border-top">Duración Artística</div>
          <div style="grid-area: 8 / span 1" class="columColor scheduleCellData__border-bottom schedule__border-right scheduleCellData__border-top">Clasificación</div>
          <div style="grid-area: 9 / span 1" class="columColor scheduleCellData__border-bottom schedule__border-right scheduleCellData__border-top">Género</div>
          <div style="grid-area: 10 / span 1" class="columColor scheduleCellData__border-bottom schedule__border-right scheduleCellData__border-top">Tipo de Contenido</div>
          <div style="grid-area: 11 / span 1; height: 100%;" class="columColor schedule__border-right scheduleCellData__border-top">Señales</div>
        </div>
        <br>   
      </el-main>
      
      <!--ALERTA -->
      <AppModal :show-dialog.sync="modalOfChapterValidation" v-if="modalOfChapterValidation" nameClass="dialog-red" 
        :rutImg="require(`../../assets/images/alerta.svg`)" sizeImg="80%"  
        :parrafo="textModal">
      </AppModal>
    </div>
  </div>
</template>

<script>
// IMPORTAR COLECCION DE STATE DE VUEX
import { mapState, mapMutations, mapActions } from 'vuex'
// IMPORTAR MOMENT
import moment from 'moment'
moment.locale('es');
// IMPORTAR COMPONENTES
import AppModal from '@/components/AppModal.vue'
import ReturnButton from '@/components/ReturnButton.vue'
// IMPORTAR DESDE ENUMS.JS
import { months } from '@/enums.js'
// IMPORTAR DESDE MAIN.JS
import { HTTP } from '@/main.js'
// IMPORTAR DESDE UTILS.JS
import { convertFirstWordTouperCase, getFirstDay } from '@/utils/calculateTime.js'
import { calculateHour, changePositionFormatDayString } from '@/utils/calculateTimePrograms.js'
import { modifyText } from '@/utils/modifyText.js'

export default {
  components: {
    ReturnButton,
    AppModal
  },
  data () {
    let typeChannel = this.$route.params.type || 'AMÉRICA TV'
    return {        
      dateSearch: this.getDateEnglish(),
      textSearch: '',
      programObj: '', 
      codeSearch: '',
      modalOfChapterValidation: false,
      textModal: null,
      gridObj: {},
      firstDayOfWeek: '',
      firstDayTable: 'Lunes',
      secondDayTable: 'Martes',
      thirdDayTable: 'Miercoles',
      fourthDayTable: 'Jueves',
      fifthDayTable: 'Viernes',
      sixthDayTable: 'Sabado',
      lastDayTable: 'Domingo',
      firstDay: '',
      secondDay: '',
      thirdDay: '',
      fourthDay: '',
      fifthDay: '',
      sixthDay: '',
      lastDay: '',
      month: '',
      year: '',
      dateString: '',
      arrOfDays: [],
      arrProgram:[],
      firstDayYeih: '',
      arrByDays:[],
      objGridInfo: {},
      completeDateArr: [],
      cardsData: [0,0,0,0,0,0,0],
      typeChannel: typeChannel,
      codeProgramSelected: '',
      // codeProgramSelected: this.$store.state.programs[0].codProgram,
      startDate: '',
      endDate: '',
      month2: '',
      year2: '',
      scheduleDinamicData: '',
      durationCortes: '',
      lastProgramSelect: JSON.parse(this.$localStorage.get("lastProgramActualizate")),
      gridData: null,
      isWeekAprovedFlag: false,
      noEsVigente: false
    }
  },
  sockets:{
    updateGridPreliminary(data){
      this.isWeekAproved()
      this.getWeekDays()
      // console.log(program)
      // alert('programa recibido de la base de datos');
    }
  },
  computed: {
    ...mapState({
      // objGridInfo: state => state.weekSelect,
      getDataWeek: state => state.allGrid
    }),
    seeElements() {
      const data = [
        // this.dateString,
        this.codeProgramSelected
      ].join()
      return data
    },
  },
  async created () {
    this.setDay()
    this.setWeek ()
    await this.programSaved()
    this.getWeekDays()
  },
  mounted(){
      if(sessionStorage.getItem('programa-parrilla')){
        // console.log('exisssssteeeeee')
      this.programObj = JSON.parse(sessionStorage.getItem('programa-parrilla'));
      this.codeProgramSelected = this.programObj.codProgram
    }
    this.findCodeProgram();
  },
  methods: {
    setDay() {
      let data = this.$route.params.day
      if(data && data !== ''){
        this.dateSearch = data
      }
    },
    setWeek() {
      if (this.dateSearch === '' || this.dateSearch === null) { 
        this.firstDayOfWeek = getFirstDay(new Date())
        this.startDate = getFirstDay(new Date())
        this.firstDay = moment(this.firstDayOfWeek).format('D')
        this.secondDay = moment(this.firstDayOfWeek).add(1, 'days').format('D')
        this.thirdDay = moment(this.firstDayOfWeek).add(2, 'days').format('D')
        this.fourthDay = moment(this.firstDayOfWeek).add(3, 'days').format('D')
        this.fifthDay = moment(this.firstDayOfWeek).add(4, 'days').format('D')
        this.sixthDay = moment(this.firstDayOfWeek).add(5, 'days').format('D')
        this.lastDay = moment(this.firstDayOfWeek).add(6, 'days').format('D')
        this.endDate = moment(this.firstDayOfWeek).add(6, 'days')._d
        this.month = convertFirstWordTouperCase(moment(this.firstDayOfWeek).format('MMMM'))
        this.month2 = convertFirstWordTouperCase(moment(this.endDate).format('MMMM'))
        this.year = moment(this.firstDayOfWeek).format('YYYY')
        this.year2 = moment(this.endDate).format('YYYY')
      } else {
        this.firstDayOfWeek = getFirstDay(new Date(this.dateSearch));
        this.startDate = getFirstDay(new Date(this.dateSearch))
        this.firstDay = moment(this.firstDayOfWeek).format('D')
        this.secondDay = moment(this.firstDayOfWeek).add(1, 'days').format('D')
        this.thirdDay = moment(this.firstDayOfWeek).add(2, 'days').format('D')
        this.fourthDay = moment(this.firstDayOfWeek).add(3, 'days').format('D')
        this.fifthDay = moment(this.firstDayOfWeek).add(4, 'days').format('D')
        this.sixthDay = moment(this.firstDayOfWeek).add(5, 'days').format('D')
        this.lastDay = moment(this.firstDayOfWeek).add(6, 'days').format('D')
        this.endDate = moment(this.firstDayOfWeek).add(6, 'days')._d
        this.month = convertFirstWordTouperCase(moment(this.firstDayOfWeek).format('MMMM'))
        this.month2 = convertFirstWordTouperCase(moment(this.endDate).format('MMMM'))
        this.year = moment(this.firstDayOfWeek).format('YYYY')
        this.year2 = moment(this.endDate).format('YYYY')
      }

      if (this.month == this.month2 && this.year == this.year2  ) {
        this.dateString = `Semana del ${this.firstDay} al ${this.lastDay} de ${this.month} del ${this.year}`
      }
      else if (this.month !== this.month2 && this.year == this.year2 ) {
        this.dateString = `Semana del ${this.firstDay} de ${this.month} al ${this.lastDay} de ${this.month2} del ${this.year}`
      }
      else if (this.month !== this.month2 && this.year !== this.year2) {
        this.dateString = `Semana del ${this.firstDay} de ${this.month} del ${this.year} al ${this.lastDay} de ${this.month2} del ${this.year2}`
      }
      this.filterWeek()
      this.programSaved()
    },
    async filterWeek() {
      // console.log('___COMO___filterWeek')
      const type = 'preliminary';
      let dataSelect = []
      this.validandoProgramaVigenteCambiandosemana()
      await this.isWeekAproved()
      if(this.gridData!=null){
        dataSelect = this.gridData.programs.filter(
          el=> el.refProgram && el.refProgram.codProgram === this.codeProgramSelected
        )
        const {_id = "There is no id",
               week = "Week not found", 
               programs = [], 
               preliminaryPrograms = [] } = this.gridData
        let fullGridData = {_id,programs,preliminaryPrograms,week}
        this.objGridInfo = {
          _id,
          count: dataSelect.length,
          fullGrid: fullGridData,
          gridMatch: dataSelect,
          weekDate: week    
        }
      }else{
        this.objGridInfo = {
          count: 0,
          fullGrid: Array(0),
          gridMatch: Array(0),
          weekDate: "Week not found",
          _id: "There is no id"
        }
      }
      console.log(this.objGridInfo._id, 'this.objGridInfo')
    },
    async findCodeProgram () {
      const channel = localStorage.getItem('channelTransmition');
      let response = await HTTP.post('programs/filterProgram',{code:this.codeSearch,channel});
      if ( response.data.docs.length == 0 ) {
        this.textModal = `<p> No se <span class="text-red text-bold"> ENCONTRÓ </span> ningún programa con este código <strong> ${this.codeSearch}</strong> </p>`
        this.modalOfChapterValidation = true 
        this.codeSearch = ''
      }
      else {
        let selectDays = this.arrByDays.filter((e) => e !== 0)
        let days = selectDays.map((e) =>( moment(e.completeDate)))
        let daysFirstSelect = this.firstDayTransmition()
        let fechaInicioDeSemanaSeleccionada = changePositionFormatDayString(new Date(daysFirstSelect).toLocaleDateString('en-GB'))
        // let fechaInicioDeSemanaSeleccionada = changePositionFormatDayString(new Date(this.firstDayOfWeek).toLocaleDateString('en-GB')) 
      
        let startVigencia = changePositionFormatDayString(response.data.docs[0].validity[0].startValidity) 
        let endVigencia =  changePositionFormatDayString(response.data.docs[0].validity[0].endValidity)
        // PROGRAMA VIGENTE
        if(Date.parse(startVigencia) <= Date.parse(fechaInicioDeSemanaSeleccionada) &&  Date.parse(endVigencia) >= Date.parse(fechaInicioDeSemanaSeleccionada) ) {
          this.programObj = response.data.docs[0]
          this.codeProgramSelected = response.data.docs[0].codProgram 
        }
        else {
           // PROGRAMA NO  VIGENTE
          this.textModal = `<p> El programa <strong> ${ response.data.docs[0].programTitle }, </strong> <span class="text-red text-bold"> NO ESTA VIGENTE </span> </p>`
          this.modalOfChapterValidation = true 
          this.codeSearch = ''
        }
      }
      this.filterWeek()
    },
    async programSaved() {
      let ultimaSemanaProgramada = this.$localStorage.get("lastWeek")
      let lastProgram = JSON.parse(this.$localStorage.get("lastProgramActualizate")) 
      let response
      if(lastProgram) {
        if(!this.codeProgramSelected) {
          response = lastProgram
        } else {
          response = await this.getProgram()
        }
      } else {
        response = await this.getProgram()
      }
    // console.log(response.codProgram, 'response.codProgram---')
     
      if(!sessionStorage.getItem('programa-parrilla')){
         this.codeProgramSelected = response.codProgram
         this.programObj = response
      }
        
    },
    getItemsByChannelTransmission(channelTransmission) {
      const programs = this.$store.getters.getProgramsByChannel(channelTransmission)
      this.codeProgramSelected = programs.length > 0 ? programs[0].codProgram : ''
      this.programObj = programs[0] ? programs[0] : {}
    },
    async getProgram() {
      let channelTransmission = (this.$localStorage.get('channelTransmition'))
      let response = await HTTP.post('programs/filterProgram',{code: this.codeProgramSelected, channelTransmission})
      if(response.data.docs.length==0) return;
      return response.data.docs[0]
    },
    addingZerosToTheDay(day){
			if(String(day).length < 2){
				day = '0'+ day
			}
			return day
    },
    async buscandoProgPorVigencia(data) {
      const {startValidity} = data
      let response = await HTTP.get(`programs/typeOfFilter/${'startValidity'}/word/${ startValidity }`)
      return response
      console.log(response, 'oooo')
    },
    fillingProgramTable(data){
      // REMOVER ELEMENTOS EXISTENTES
      const arrOfClasses = ['newDiv', 'newDivEmpty']
      this.removePreviousDivs(arrOfClasses)
      // RECORRER NUEVA DATA Y CREAR DIVS
      let newData = data.filter(item => item.aItems !== "Duraccion")
      newData.map((fila, i)=>{
        const dataLength = data.length
        const keys = Object.keys(fila)
        if(fila.aItems == 'Inicio' || fila.aItems == 'Final' || fila.aItems == 'Capítulo' || fila.aItems == 'Estado'){
          keys.map((key, index)=>{
            if(index > 0){
              let objOfDay = this.arrByDays[index-1]
              const validateContent = fila[key] !== '' && fila[key] !== undefined
              const validateContentAfter = fila[keys[index+1]] !== '' && fila[keys[index+1]] !== undefined
              this.createNewDiv(fila, key, validateContent, validateContentAfter, objOfDay)
              
            }
          })
        }
        if(fila.aItems == 'Material' || fila.aItems == 'N° de Cortes' || fila.aItems == 'Duración Artística'
            || fila.aItems == 'Clasificación' || fila.aItems == 'Género' || fila.aItems == 'Tipo' || fila.aItems == 'Señales'){
          let arr = []
          keys.map((key, index)=>{
            if(index > 0){
              let objOfDay = (index>1)?this.arrByDays[index-2]:0
              let classVerify = (objOfDay!== 0)?this.validateCrossover(objOfDay, '', 'redText'):''
              
              // DEBE VERIFICAR SI EL ANTERIOR ES IGUAL A ESTE
              if(fila[key] == fila[keys[index-1]]){
                const isTrue = (fila[keys[index+1]] !== '') && (index !==  keys.length - 1)
                this.generatingDivs(fila, key, index, keys, arr, isTrue, i, dataLength, classVerify)
              } else {
                const classToAdd = ['newDiv', 'newDiv border-b-0']
                this.createColspanDiv(arr, fila, keys, classToAdd, i, dataLength, classVerify, index)
                arr = []
                const isTrue = (fila[keys[index+1]] !== '') && (index !==  keys.length - 1)
                this.generatingDivs(fila, key, index, keys, arr, isTrue, i, dataLength, classVerify)
              }
            }
            // console.log(this.arrByDays, 'this.arrByDays')
          })
        }
        
      })
    },
    /*Methods to Fill Table Structure */
    removePreviousDivs(arr){
      arr.map((el)=>{
        document.querySelectorAll('.'+el).forEach(function(a){
          a.remove()
        })
      })
    },
    createNewDiv(fila, prop, boolean, booleanAfter, objOfDay) {
      const divToAdd = document.createElement('div')
      if(boolean){
        let holis = ( objOfDay !== 0 ) ? this.validateCrossover( objOfDay, '' , 'redText' ) : ''
        divToAdd.className = (prop == 'hLastDayStart')? `newDiv border-r-0 ${holis}`:`newDiv ${holis}`
      } else {
        divToAdd.className = (booleanAfter)?'newDivEmpty schedule__border-right': 'newDivEmpty'
      }
      divToAdd.innerHTML = fila[prop]
      this.$refs.scheduleData.appendChild(divToAdd)
    },
    createColspanDiv(arr, fila, keys, newClass, i, dataLength, classVerify, index) {
      let days = ['Lunes', 'Martes', 'Miercoles', 'Jueves', 'Viernes', 'Sabado', 'Domingo']
      if(arr.length > 0) {
        const newDiv = document.createElement('div')
        if(fila.aItems == 'N° de Cortes' &&  fila[keys[arr[0]]] !== 'Sin Cortes') {
          const containerT = document.createElement('div')
          let span = document.createElement('span')
          span.className = 'tooltiptext'
          if ( arr.length > 1 ) {
            let hola = ''
            arr.map((el, i, array) => {
              hola += `<span class="text-orange text-bold"> ${days[array[i] - 1 ]}: </span> <br>`
              let mam = this.arrProgram
              if( i > 0) {
                if ( mam[5][keys[el]]  !== hola ) {
                  hola += mam[5][keys[el]]  + ' <br> ' 
                }
              }
              else {
                hola += mam[5][keys[el]] + ' <br>' 
              }        
            })
            span.innerHTML = hola
          }
          else {
            let text = `<span class="text-orange text-bold"> ${days[arr[0] - 1 ]}: </span> <br> ${ this.arrProgram[5][keys[arr[0]]] }`
            span.innerHTML = text
          }
          
          containerT.innerHTML = fila[keys[arr[0]]]
          containerT.className = 'tooltip'
          containerT.appendChild(span)
          newDiv.appendChild(containerT)
        }
        else {
          newDiv.innerHTML = fila[keys[arr[0]]]
        }
   
        let data = dataLength
        let classAdd = ''
        if(arr.includes(index-1)){
          classAdd = classVerify
        }
        if(i == (data -1)){
          classAdd = classAdd + ' '+ newClass[1]
        } else {
          classAdd = classAdd + ' '+ newClass[0]
        }
        newDiv.className = classAdd
        newDiv.style.gridArea = `${i+1} / ${arr[0] +1} / ${i+2} / span ${arr.length}`
        this.$refs.scheduleData.appendChild(newDiv)
      }
    },
    createDivEmpty(isTrue) {
      const newDiv = document.createElement('div')
      newDiv.className = (isTrue)?'newDivEmpty schedule__border-right':'newDivEmpty'
      this.$refs.scheduleData.appendChild(newDiv)
    },
    generatingDivs(fila, key, index, keys, arr, isTrue, i, data, classVerify){
      if(fila[key] !== ''){
        arr.push(index)
        if(index == (keys.length -1)){
          let classToAdd = ['newDiv border-r-0', 'newDiv border-r-0 border-b-0']
          
          const dataLength = data
          this.createColspanDiv(arr, fila, keys, classToAdd, i, dataLength, classVerify, index)
          arr = []
        }
      } else {
        this.createDivEmpty(isTrue)
      }
    },
    /*------ */
    returnPage(value) {
      // if(value) {
        this.$router.push({ name: 'views', params: {subTitle: this.typeChannel} })
      // }
    },
    headerRowClass({row, rowIndex}) {
      if (rowIndex === 0) {
        return 'orangeHead';
      } 
    },
    getDateEnglish() {
      let completeObjectParse = JSON.parse(this.$localStorage.get("programedProgram"));
      let miliseconds;
      if (completeObjectParse === '' || completeObjectParse == null ) {
        miliseconds = new Date()
      } else {
        let dateString = new Date(completeObjectParse.year, completeObjectParse.month, completeObjectParse.day)
        miliseconds = dateString.getTime();
      }
      return miliseconds
    },
    getWeekDays() {
      this.cardsData = [0,0,0,0,0,0,0]
      this.durationCortes = []
      let weekDays = [this.firstDay.toString(), this.secondDay.toString(), this.thirdDay.toString(), this.fourthDay.toString(), this.fifthDay.toString(), this.sixthDay.toString(), this.lastDay.toString()]
        this.firstDayTable = `Lunes ${weekDays[0]}`
        this.secondDayTable = `Martes ${weekDays[1]}`
        this.thirdDayTable = `Miércoles ${weekDays[2]}`
        this.fourthDayTable = `Jueves ${weekDays[3]}`
        this.fifthDayTable = `Viernes ${weekDays[4]}`
        this.sixthDayTable = `Sábado ${weekDays[5]}`
        this.lastDayTable = `Domingo ${weekDays[6]}`
        this.$localStorage.set('programedProgram', JSON.stringify(''))
        // console.log(weekDays, 'weekDays')
        this.dataGetter(this.programObj, weekDays, this.objGridInfo)
    },
    getFullDateOfTransmissionsDays () {
      // METODO PARA GENERAR LAS FECHAS COMPLETAS DE LOS DIAS DE TRANSMISION
      let arrTransmissionDays = this.programObj.transmissionDays
      let day
      let arrCompleteDays = []
      for (let x = 0; x < arrTransmissionDays.length; x++) {
        switch (modifyText(arrTransmissionDays[x])) {
          case 'lunes':
            day = this.firstDayOfWeek
            break;
          case 'martes':
            day = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000))
            break;
          case 'miercoles':
            day = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*2)
            break;
          case 'jueves':
            day = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*3)
            break;
          case 'viernes':
            day = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*4)
            break;
          case 'sabado':
            day = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*5)
            break;
          case 'domingo':
            day = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*6)
            break;
        }

        let dateTime = moment(day)
        let mes = convertFirstWordTouperCase(dateTime.format('MMMM'))
        let dia = convertFirstWordTouperCase(dateTime.format('dddd')) 
        let numberDay = dateTime.format('D')
        let anio = dateTime.format('YYYY')
        let space = ' '

        let dateSentence = dia + space + numberDay  + space +   'de' + space + mes + space + 'del' + space + anio
        arrCompleteDays.push(dateSentence);
      }
      return arrCompleteDays
    },
    // METODO PARA VALIDAR CRUCE DE PROGRAMAS EN LA DATA
    verifyProgramCrossover(obj, isEmpty, arrItems, element, textToShow){
      if(obj !== 0){
        if(isEmpty) {
          arrItems[arrItems.length -1][ element ] = '';
        } else {
          // ACA VA EL METODO DE LA VALIDACION DE CHECK CROSSES
          arrItems[ arrItems.length -1 ][ element ] = this.validateCrossover(obj, textToShow)
          if ( arrItems.length == 7 ) {
             arrItems[5][element ] = this.durationCortes
          }
        }
      } else {
        arrItems[arrItems.length -1][ element ] = '';
      }
    },
    // METODO PARA VERIFICAR SI EL PROGRAMA TIENE CRUCE DE HORARIO
    validateCrossover(obj, value1, value2){
      let arrCheckCrosses = obj.arrCheckCrosses
      let lastValue = ''
      if(arrCheckCrosses !== undefined && arrCheckCrosses.length > 0){
        arrCheckCrosses.map((crossObject)=>{
          if(crossObject.title == obj.programGridTitle){
            crossObject.completeDaysCrushed.map((dayWithCross)=>{
              if(dayWithCross == obj.completeDate){
                let time = (crossObject.time).trim()
                if(time == 'Todo el horario'){
                  if(!value2){
                    value2 = `El programa "${crossObject.newProgram}" ocupó todo su horario`
                  }
                  lastValue = value2
                  // arrItems[arrItems.length -1][ element ] = `El programa ${crossObject.newProgram} ocupó todo su horario`
                } else {
                  lastValue = value1
                  // arrItems[arrItems.length -1][ element ] = textToShow;
                }
              } else {
                lastValue = value1
                // arrItems[arrItems.length -1][ element ] = textToShow;
              }
            })
          }
        })
      } else{
        lastValue = value1
        // arrItems[arrItems.length -1][ element ] = textToShow;
      }

      return lastValue
    },
    // METODO PARA VALIDAR SI LOS CAPS TIENEN CORTES

    verifyCapsCuts (objChapter, cutsOfMaterial, allChapters, prop, text) {
      const notCuts = text
      let infoToShow = ''
      if (cutsOfMaterial.length > 0) {
        if (allChapters.length > 0 ) {
          let data = cutsOfMaterial
          let typeCut =  data.length > 0 &&  data[0].allChapters.cuts.length > 0 ? 'allChapters' : "ranger and caps"
          if (typeCut == 'allChapters' ) {
            let string = ''
            data[0].allChapters.cuts.map((el, i, arr) => {
              string += i !== arr.length -1 ? (el.duration).slice(3,5)  + ' min - ' : (el.duration).slice(3,5)  + ' min' 
            })
            this.durationCortes = string
          }
          
          let typeSubCut;
          switch(typeCut) {
            case 'allChapters':
              infoToShow = (typeof data[0].allChapters[prop] == 'string')?data[0].allChapters[prop]:data[0].allChapters[prop].length
              typeSubCut= 'allChapters'
            break;
            default:
              if(data[0]) {
                /*Por capítulos individuales y rangos*/
                if(data[0].individualChapters.length > 0 && data[0].chapterRanges.length > 0) {
                  let array = []
                  allChapters.map((chapter)=>{
                    let dataChapters = []
                    data[0].chapterRanges.map((object)=>{
                      if((object.startChapter <= chapter) && (object.finalChapter >= chapter)){
                        dataChapters = object[prop]
                      }
                    })
                     let string = ''
                    data[0].individualChapters.map((iChapter)=>{
                        
                      if(iChapter.chapter == chapter) {
                        dataChapters = iChapter[prop]
                      }
                    })

                    if(dataChapters.length > 0){
                      array.push(dataChapters)
                    } else {
                      array.push(notCuts)
                    }

                  })
                  
                  this.durationCortes  = ''
                  let string = ''
                  let dataByChap = []
                  array.map((chap, y, arr )=>{
                    if(chap == notCuts) {
                      dataByChap.push(chap)
                    } else {
                      if(typeof chap == 'string'){
                        dataByChap.push(chap)
                      } else {
                        string += ` <span class="text-ligth"> cap n° ${allChapters[y]}: </span>  &nbsp `
                        dataByChap.push(chap.length)
                        chap.map((el, i, arr) => {
                          string += i !== arr.length -1 ? (el.duration).slice(3,5)  + ' min - ' : (el.duration).slice(3,5)  + ' min' 
                        })
                        string += y !== arr.length -1 ?  ' <br> '   :  ''      
                      }
                    }
                  })
                  

                  this.durationCortes = string
                  infoToShow = dataByChap.join(' - ')
                  typeSubCut= 'rangerChaptersAndIndividual'

                /*Por capítulos individuales*/
                }
                 else if(data[0].individualChapters.length > 0) {
                  let array = []
                  allChapters.map((chapter, indx)=> {
                    let dataChapters = []
                    let string = ''
                    if(chapter == ''){
                      chapter = 1
                    }
                    data[0].individualChapters.map((iChapter)=>{
                      if(iChapter.chapter == chapter){
                        dataChapters = iChapter[prop]
                      }
                    })

                    if(dataChapters.length > 0){
                      array.push(dataChapters)
                    } else {
                      array.push(notCuts)
                    }
                  })
                  let dataByChap = []
                  this.durationCortes  = ''
                  let string = ''
                  array.map((chap, y, arr) => {
                    if(chap == notCuts){
                      dataByChap.push(chap)
                    } else {
                      if(typeof chap == 'string'){
                        dataByChap.push(chap)
                      } else {
                        string += ` <span class="text-ligth"> cap n° ${allChapters[y]}: </span> &nbsp `
                        dataByChap.push(chap.length)
                        chap.map((el, i, arr) => {
                          string += i !== arr.length -1 ? (el.duration).slice(3,5)  + ' min - ' : (el.duration).slice(3,5)  + ' min' 
                        })
                        string += y !== arr.length -1 ?  '<br>':  ''                  
                      }
                    }
                  })
                  this.durationCortes = string
                  infoToShow = dataByChap.join(' - ')
                  typeSubCut= 'individualChapters'
                /*Por rangos*/
                } else if(data[0].chapterRanges.length > 0){
                  let array = []
                  allChapters.map((chapter)=>{
                    let dataChapters = []
                    data[0].chapterRanges.map((object)=>{
                      if((object.startChapter <= chapter) && (object.finalChapter >= chapter)){
                        dataChapters = object[prop]
                      }
                    })

                    if(dataChapters.length > 0){
                      array.push(dataChapters)
                    } else {
                      array.push(notCuts)
                    }
                  })

                  this.durationCortes  = ''
                  let string = ''
                  let dataByChap = []
                  array.map((chap, y, arr)=> {
                    if(chap == notCuts) {
                      dataByChap.push(chap)
                    } else {
                      if(typeof chap == 'string') {
                        dataByChap.push(chap)
                      } else {
                        string += `<span class="text-ligth"> cap n° ${allChapters[y]} :<span> &nbsp`
                        dataByChap.push(chap.length)
                        chap.map((el, i, arr) => {
                          string += i !== arr.length -1 ? (el.duration).slice(3,5)  + ' min - ' : (el.duration).slice(3,5)  + ' min' 
                        })
                        string += y !== arr.length -1 ?  '<br>':  ''  
                      }
                    }
                  })
                  this.durationCortes = string
                  infoToShow = dataByChap.join(' - ')
                  typeSubCut= 'rangerChapters'
                } else {
                  infoToShow = notCuts
                  typeSubCut= 'ninguno'
                }
              } 
            break;
          }      
        }
      }
      return infoToShow
    },
    dataGetter(programObject, arrWeekDates, gridInfo) {
      let dayNames = ['Lunes', 'Martes', 'Miercoles', 'Jueves', 'Viernes', 'Sabado', 'Domingo'];
      let newArr = [];
      let newDates = [0,0,0,0,0,0,0];
      let insertGrid = [0,0,0,0,0,0,0];

      // ACA SE LLENA LA DATA DE LA TABLA
      // let materialProperty = (gridInfo.gridMatch.length > 0)?(programObject.material)?programObject.material:'':''
      programObject.transmissionDays.map((el, i, arr) => {
        if(el === "Lunes") {
          newArr.push(arrWeekDates[0])
        } else if (el === "Martes") {
          newArr.push(arrWeekDates[1])
        } else if (el === "Miércoles") {
          newArr.push(arrWeekDates[2])
        } else if (el === "Jueves") {
          newArr.push(arrWeekDates[3])
        } else if (el === "Viernes") {
          newArr.push(arrWeekDates[4])
        } else if (el === "Sábado") {
          newArr.push(arrWeekDates[5])
        } else if (el === "Domingo") {
          newArr.push(arrWeekDates[6])
        }
      })
      
      newArr.map((el, i, arr) => {
        if(el == arrWeekDates[0]) {
          newDates.splice(0, 1, el);
        } else if(el === arrWeekDates[1]) {
          newDates.splice(1, 1, el);
        } else if(el === arrWeekDates[2]) {
          newDates.splice(2, 1, el);
        } else if(el === arrWeekDates[3]) {
          newDates.splice(3, 1, el);
        } else if(el === arrWeekDates[4]) {
          newDates.splice(4, 1, el);
        } else if(el === arrWeekDates[5]) {
          newDates.splice(5, 1, el);
        } else if(el === arrWeekDates[6]) {
          newDates.splice(6, 1, el);
        }
      })

      // console.log(newDates, 'newDates')
      // console.log(gridInfo.gridMatch, 'gridInfo.gridMatch')

      newDates.map((el,i,arr) => {
        if(gridInfo.gridMatch && el !== 0) {
          gridInfo.gridMatch.map((element, index, array) => {
            if(element.dailyProgramDate == el) {
              newDates.splice(i, 1, element);
              this.cardsData.splice(i, 1, newDates[i]);
            }  
          })
        }
      })

      //  console.log(newDates, 'newDates despues')

      // GENERAR LAS FECHA COMPLETA DE LOS DIAS
      let daysWithFullDate = this.getFullDateOfTransmissionsDays()
      for(let i=0; i<newDates.length; i++){
        if(typeof newDates[i] === 'string') {
          let newProgramObj = {
            chapters: [{
              numChapter: "",
              season: "",
              seasonInfo: "",
              status: "",
              ongoing: false
            }],
            // dailyCuttingProgram: (materialProperty == '')?[]:materialProperty.videoCutting,
            dailyCuttingProgram: [],
            crushedPrograms: programObject.crushedPrograms,
            // artisticDuration:"",
            replacementPrograms: [],
            programGridTitle: programObject.programTitle,
            dailyProgramDate: "",
            completeDate: "",
            scheduleStartHour: programObject.scheduleStartHour,
            scheduleStartMin: programObject.scheduleStartMin,
            scheduleEndHour: programObject.scheduleEndHour,
            scheduleEndMin: programObject.scheduleEndMin,
            materialTitle: "",
            codMaterial: "",
            // material: materialProperty,
            material: {},
            refProgram: programObject,
            materialReferencia: {},
            isShowTemporadas: false,
            programDate: '',
            geminisCodeProgram: programObject.geminisCode,
            arrCheckCrosses: programObject.arrCheckCrosses,
          }
          for(let m=0; m<daysWithFullDate.length; m++){
            let daySelect = daysWithFullDate[m].split(' ')[1]
            if(daySelect == newDates[i]){
              newProgramObj.completeDate = daysWithFullDate[m]
            }
          }
          
          newDates.splice(i, 1, newProgramObj);
          this.cardsData.splice(i, 1, newDates[i]);
        }
      }
      // END
      this.arrByDays = newDates
      this.arrProgram = []
      
      if(this.arrByDays && this.arrByDays.length) {
        let items = ['Inicio', 'Final', 'Material', 'Capítulo', 'Estado', 'Duraccion', 'N° de Cortes', 'Duración Artística', 'Clasificación','Género','Tipo', 'Señales'];
        let arrItems = []
        let colItems = ['bFirstDayStart', 'cSecondDayStart', 'dthirdDayStart', 'eFourthDayStart', 'fFifthDayStart', 'gSixthDayStart', 'hLastDayStart'];
          
        let arrDaysOfWeek = [this.firstDayTable, this.secondDayTable, this.thirdDayTable, this.fourthDayTable, this.fifthDayTable, this.sixthDayTable, this.lastDayTable]

        items.map((el, i, arr) => {
          arrItems.push({ aItems: el })
          colItems.map((element, index, array) => {
            let principalObject = this.arrByDays[index]
            let isEmpty, textToShow 
            switch (el) {           
              case 'Inicio':
                isEmpty = this.arrByDays[index].scheduleStartHour === ''
                textToShow = calculateHour(this.arrByDays[index].scheduleStartHour) + ':' + calculateHour(this.arrByDays[index].scheduleStartMin)
                this.verifyProgramCrossover(principalObject, isEmpty, arrItems, element, textToShow)
              break;
              case 'Final':
                isEmpty = this.arrByDays[index].scheduleEndHour === ''
                textToShow = calculateHour(this.arrByDays[index].scheduleEndHour) + ':' + calculateHour(this.arrByDays[index].scheduleEndMin)
                this.verifyProgramCrossover(principalObject, isEmpty, arrItems, element, textToShow)
              break;
              case 'Capítulo':
                let chapArr = []
                let chaptersString = ''
                isEmpty = (this.arrByDays[index].chapters == undefined)
                if(!isEmpty){
                  this.arrByDays[index].chapters.map((el,i,arr) => {
                    chapArr.push(el.numChapter);
                  })
                  chaptersString = chapArr.join(' - ');
                  // if(chaptersString == '' && (this.arrByDays[index].material.listTitle !== '' && this.arrByDays[index].material.listTitle !== undefined)){
                  //   chaptersString = 1
                  // }
                }
                
                textToShow = chaptersString
                this.verifyProgramCrossover(principalObject, isEmpty, arrItems, element, textToShow)
              break;
              case 'Material':
                isEmpty = (this.arrByDays[index].artisticDuration !== undefined)
                if(principalObject !== 0){
                  const {material, materialTitle} = this.arrByDays[index]
                  if(material) {
                    textToShow = material.listTitle !== undefined ? material.listTitle : ''
                  } else {
                    textToShow = materialTitle ? materialTitle : ''
                  }
                } else {
                  textToShow = ''
                }               
                this.verifyProgramCrossover(principalObject, isEmpty, arrItems, element, textToShow)
              break;
              case 'Estado':
                let stateArr = []
                let stateString = ''
                isEmpty = (this.arrByDays[index].chapters == undefined)
                if(!isEmpty){
                  this.arrByDays[index].chapters.map((el,i,arr) => {
                    let statusChapter = []
                    if(el.rerun){
                      statusChapter.push('Rerun')
                    }
                    if(el.estreno){
                      statusChapter.push('Estreno')
                    }
                    if(el.ongoing){
                      statusChapter.push('Ongoing')
                    }
                    
                    let stateFinal = statusChapter.join(' - ')
                    stateArr.push(stateFinal)
                  })
                  stateString = stateArr.join(' / ')
                }

                textToShow = stateString
                this.verifyProgramCrossover(principalObject, isEmpty, arrItems, element, textToShow)
              break;
              case 'N° de Cortes':
                let allChapters = []
                let cutsOfMaterial= []
                
                if(principalObject !== 0){
                  if(this.arrByDays[index].dailyCuttingProgram !== undefined){
                    cutsOfMaterial = this.arrByDays[index].dailyCuttingProgram
                  } else {
                    cutsOfMaterial = []
                  }
                } else {
                  cutsOfMaterial = []
                }
                
                isEmpty = (this.arrByDays[index].chapters == undefined)
                if(!isEmpty) {
                  this.arrByDays[index].chapters.map((el,i,arr) => {
                    allChapters.push(el.numChapter);
                  })
                }

                const text = 'Sin Cortes'
                textToShow = this.verifyCapsCuts(this.arrByDays[index].chapters, cutsOfMaterial, allChapters, 'cuts', text)
                this.verifyProgramCrossover(principalObject, isEmpty, arrItems, element, textToShow)
              break;
              case 'Duración Artística':
                let chaptersOfDay = []
                let cutsMaterial= []
                if(principalObject !== 0){
                  if(this.arrByDays[index].dailyCuttingProgram !== undefined){
                    cutsMaterial = this.arrByDays[index].dailyCuttingProgram
                  } else {
                    cutsMaterial = []
                  }
                } else {
                  cutsMaterial = []
                }

                isEmpty = (this.arrByDays[index].chapters == undefined)
                if(!isEmpty){
                  this.arrByDays[index].chapters.map((el,i,arr) => {
                    chaptersOfDay.push(el.numChapter);
                  })
                }
                const noShow = '-'
                textToShow = this.verifyCapsCuts(this.arrByDays[index].chapters, cutsMaterial, chaptersOfDay, 'artisticDuration', noShow)
                this.verifyProgramCrossover(principalObject, isEmpty, arrItems, element, textToShow)

                // if(gridInfo.gridMatch[index]) {
                //   let data = gridInfo.gridMatch[index].dailyCuttingProgram
                //   let durationArtisticAboutCuts = data[0].allChapters.artisticDuration
                //   arrItems[arrItems.length -1][ element ] = durationArtisticAboutCuts
                // } else {
                //   arrItems[arrItems.length -1][ element ] = '';
                // }
                
              break;
              case 'Clasificación':
                isEmpty = (this.arrByDays[index].artisticDuration !== undefined)
                if(principalObject !== 0){
                  const {material, classification} = this.arrByDays[index]
                  if(material) {
                    textToShow = material.classification !== undefined ? material.classification : ''
                  } else {
                    textToShow = classification ? classification : ''
                  }
                } else {
                  textToShow = ''
                }
                
                this.verifyProgramCrossover(principalObject, isEmpty, arrItems, element, textToShow)
              break;
              case 'Género':
                isEmpty = (this.arrByDays[index].artisticDuration !== undefined)
                if(principalObject !== 0){
                  const {material} = this.arrByDays[index]
                  if(material) {
                    textToShow = material.genre !== undefined ? material.genre : ''
                  } else {
                    textToShow = ''
                  }
                } else {
                  textToShow = ''
                }
                
                this.verifyProgramCrossover(principalObject, isEmpty, arrItems, element, textToShow)
              break;
              case 'Tipo':
                isEmpty = (this.arrByDays[index].artisticDuration !== undefined)
                if(principalObject !== 0){
                  const {material, typeOfContent} = this.arrByDays[index]
                  if(material) {
                    textToShow = material.typeOfContent !== undefined ? material.typeOfContent : ''
                  } else {
                    textToShow =  typeOfContent ? typeOfContent : ''
                  }
                } else {
                  textToShow = ''
                }
                
                this.verifyProgramCrossover(principalObject, isEmpty, arrItems, element, textToShow)
              break;
              case 'Señales':
                isEmpty = (this.arrByDays[index].artisticDuration !== undefined)
                if(principalObject !== 0){
                  if(this.arrByDays[index].refProgram.checkedSignals.length > 0){
                    textToShow = this.arrByDays[index].refProgram.checkedSignals.toString()
                  } else {
                    textToShow = ''
                  }
                } else {
                  textToShow = ''
                }
                
                this.verifyProgramCrossover(principalObject, isEmpty, arrItems, element, textToShow)
              break;
              default: 
                arrItems[arrItems.length -1][ element ] = '';
            }
          })
        })
        this.arrProgram = arrItems
      }  
    },
    // getPrograms() {
    //   this.$localStorage.set('programedProgram', JSON.stringify(''))
    //   let dataType = 'programs';
    //   this.$store.dispatch("getData", dataType);
    // },
    async querySearch (queryString, cb) {
      const channel = localStorage.getItem('channelTransmition');
      let response = await HTTP.post('programs/filterProgram',{channel,title:queryString})
      if(response.data.docs.length==0) return;
      cb(response.data.docs)
    },
    createFilter (queryString) {
      return (link) => {
        return (modifyText(link.programTitle).indexOf(modifyText(queryString)) === 0);
      }
    },
    handleSelect (item) {
      console.log(item, 'a')
      let selectDays = this.arrByDays.filter((e) => e !== 0)
      let days = selectDays.map((e) =>( moment(e.completeDate)))
      let daysFirstSelect = this.firstDayTransmition()
      let fechaInicioDeSemanaSeleccionada = changePositionFormatDayString(new Date(daysFirstSelect).toLocaleDateString('en-GB'))
      // let fechaInicioDeSemanaSeleccionada = changePositionFormatDayString(new Date(this.firstDayOfWeek).toLocaleDateString('en-GB')) 
      let startVigencia = changePositionFormatDayString(item.validity[0].startValidity) 
      let endVigencia =  changePositionFormatDayString(item.validity[0].endValidity) 
      if(Date.parse(startVigencia) <= Date.parse(fechaInicioDeSemanaSeleccionada) &&  Date.parse(endVigencia) >= Date.parse(fechaInicioDeSemanaSeleccionada) ) {
        this.programObj = item
        this.codeProgramSelected = item.codProgram
        this.durationCortes = ''
      }
      else {
        // PROGRAMA NO  VIGENTE
        this.textModal = `<p> El programa <strong> ${ item.programTitle }, </strong> <span class="text-red text-bold"> NO ESTA VIGENTE </span> </p>`
        this.modalOfChapterValidation = true 
      }
      this.filterWeek()
    },
    firstDayTransmition() {
      let arrTransmissionDays = this.programObj.transmissionDays
      let day, dateTime
      let total = []
      // console.log(arrTransmissionDays, 'arrTransmissionDays')
      // for (var i = 0; i < arrTransmissionDays.length; i++) {
      if(arrTransmissionDays && arrTransmissionDays.length >0) {
        arrTransmissionDays.forEach((e, i) => {
          switch (modifyText(arrTransmissionDays[i])) {
            case 'lunes':
              day = this.firstDayOfWeek
              break;
            case 'martes':
              day = moment(this.firstDayOfWeek).add(1, 'days')._d
              break;
            case 'miercoles':
              day = moment(this.firstDayOfWeek).add(2, 'days')._d
              break;
            case 'jueves':
              day = moment(this.firstDayOfWeek).add(3, 'days')._d
              break;
            case 'viernes':
              day = moment(this.firstDayOfWeek).add(4, 'days')._d
              break;
            case 'sabado':
              day = moment(this.firstDayOfWeek).add(5, 'days')._d
              break;
            case 'domingo':
              day = moment(this.firstDayOfWeek).add(6, 'days')._d
              break;
          }
          dateTime = moment(day)
          total.push(dateTime._d)
        })
      }
      
      return total.length >0 ? total[0] : []
    },
    programObjectInfo (routeName, gridInfo) {
      let arrTransmissionDays = this.programObj.transmissionDays
      let day

      for (var i = 0; i < arrTransmissionDays.length; i++) {
        switch (modifyText(arrTransmissionDays[i])) {
          case 'lunes':
            day = this.firstDayOfWeek
            break;
          case 'martes':
            day = moment(this.firstDayOfWeek).add(1, 'days')._d
            break;
          case 'miercoles':
             day = moment(this.firstDayOfWeek).add(2, 'days')._d
            break;
          case 'jueves':
             day = moment(this.firstDayOfWeek).add(3, 'days')._d
            break;
          case 'viernes':
            day = moment(this.firstDayOfWeek).add(4, 'days')._d
            break;
          case 'sabado':
            day = moment(this.firstDayOfWeek).add(5, 'days')._d
            break;
          case 'domingo':
            day = moment(this.firstDayOfWeek).add(6, 'days')._d
            break;
        }

        let dateTime = moment(day)
        let dd = convertFirstWordTouperCase(dateTime.format('dddd'))
        let numberOfDay = Number(dateTime.format('D'))
        let month = convertFirstWordTouperCase(dateTime.format('MMMM'))
        let year = dateTime.format('YYYY')

        let date = {
          programDate: dateTime._d,
          day: dd, 
          numberOfDay: numberOfDay,
          month: month,
          year: year,
          monthNumber: months.indexOf(months[day.getMonth()]) + 1
        }

        let dateSentence = `${ dd } ${ numberOfDay } de ${ month} del ${ year }`
        this.arrOfDays.push(date)
        this.completeDateArr.push(dateSentence);
      }

      let isHaveId
      const {gridMatch = []} = gridInfo
      if(gridMatch.length !== 0) {
        isHaveId = gridMatch[0].materialReferencia ? gridMatch[0].materialReferencia._id ? gridMatch[0].materialReferencia._id : gridMatch[0].materialReferencia.__id : null
      } else {
        isHaveId = null
      }
      let payload = {
        dataSentence: this.completeDateArr,
        programInfo: this.programObj,
        grid: gridInfo,
        dateString: this.dateString,
        day: this.firstDay,
        month: this.firstDayOfWeek.getMonth(),
        year: this.year,
        cardsData: this.cardsData,
        arrOfDays: this.arrOfDays,
        codMaterial: isHaveId,
        codProgram: this.codeProgramSelected,
        dateStart: this.startDate,
        dateEnd: this.endDate,
      }

      this.$localStorage.set('gridPayload', JSON.stringify(payload))
       this.$store.dispatch('sendProgramObj', this.programObj)

      this.$router.push({name: routeName, params: {type: this.typeChannel, day: this.dateSearch}})
    },
    isShowEditCut() {
      const { count, gridMatch } = this.objGridInfo
      if(!count || count == 0) {
        return true
      } else {
        let coincidence = []
        gridMatch.map((el) => {
          el.dailyCuttingProgram.length > 0 ? coincidence.push('exist') : ''
        })
        return coincidence.length > 0 ? false : true
      }
    },
    async isWeekAproved() {
      this.gridData = null
      this.noEsVigente = true
      let response = await HTTP.post('grid/filterWeek',{week:this.dateString})
      const responseData = response.data.ok? response.data.grid : null;
      this.gridData = responseData
      if(responseData) this.isWeekAprovedFlag = responseData.approvedWeek
      else this.isWeekAprovedFlag = false
      this.validandoProgramaVigenteCambiandosemana()
      // this.noEsVigente = false
    },
    async validandoProgramaVigenteCambiandosemana() {
      let selectDays = this.arrByDays.filter((e) => e !== 0)
      let days = selectDays.map((e) =>( moment(e.completeDate)))
      let daysFirstSelect = this.firstDayTransmition()
      let fechaInicioDeSemanaSeleccionada = changePositionFormatDayString(new Date(daysFirstSelect).toLocaleDateString('en-GB'))
      
      let dataVigencia = this.programObj.validity && this.programObj.validity.length > 0 ? this.programObj.validity[0] : {}
      if(dataVigencia.startValidity) {
        let startVigencia = changePositionFormatDayString(dataVigencia.startValidity) 
        let endVigencia =  changePositionFormatDayString(dataVigencia.endValidity)
        // PROGRAMA VIGENTE
        if(Date.parse(startVigencia) <= Date.parse(fechaInicioDeSemanaSeleccionada) &&  Date.parse(endVigencia) >= Date.parse(fechaInicioDeSemanaSeleccionada) ) {
          this.noEsVigente = false
        }
        else {
          // PROGRAMA NO  VIGENTE
          console.log('programa no vigente')
          this.textModal = `<p> El programa <strong> ${ this.programObj.programTitle }, </strong> <span class="text-red text-bold"> NO ESTA VIGENTE </span> </p>`
          this.modalOfChapterValidation = true 
          this.codeSearch = ''
          this.noEsVigente = true
        }
      }
      // console.log(dataVigencia.startValidity, 'dataVigencia.startValidity')
      // console.log(this.noEsVigente, 'this.noEsVigente')
    }
  },
  watch: {
    noEsVigente(val) {
      console.log(val, 'noEsVigente')
    },
    programObj(){
      sessionStorage.setItem('programa-parrilla',JSON.stringify(this.programObj));
    },
		arrProgram:{
			handler(newVal, oldVal){
				if(newVal !== ''){
          this.fillingProgramTable(newVal)
        }
			},
			// immediate: true
    },
    objGridInfo(val) {
      if(this.dateString != '' && this.codeProgramSelected != '') {
        this.getWeekDays()
      }
    },
    getDataWeek: {
      handler(newVal, oldVal){
        if(newVal !== oldVal){
          this.getWeekDays()
        }
      }
    }
	}
}
</script>

<style scoped>
  /* GRILLA DE LOS DIAS */
  .scheduleProgramming{
    display: grid;
    grid-template-columns: repeat(8, 152.1px);
    align-items: center;
    border: 2px #828282 solid;
  }

  .scheduleDay{
    background: #FF7333;
    color: white;
    font-weight: 500;
    font-size: 18px;
    text-align: center;
    text-transform: uppercase;
    padding: 8px 0;
  }
  .scheduleDay-border{
    border-right: 2px #828282 solid;
  }
  /* GRILLA DE LA DATA */
  .scheduleData{
    display: grid;
    grid-template-columns: repeat(8, 152.1px);
    grid-template-rows: repeat(11, minmax(55px, max-content));
    border: 2px #828282 solid;
    border-top: 0;
    background: #E0E0E0;
  }
  .schedule__border-right{
    border-right: 2px #828282 solid;
  }
  .scheduleCellData__border-bottom{
    border-bottom: 1px #828282 solid;
  }
  .scheduleCellData__border-top{
    border-top: 1px #828282 solid;
  }
  /* ESTILOS DE LOS DIVS DE LA DATA */
  .newDiv{
    background: white;
    border-right: 2px solid #828282 ;
    border-bottom: 1px solid #828282;
    border-top: 1px solid #828282;
    text-align: center;
    display: flex;
    justify-content: center;
    align-items: center;
  }
  .border-r-0{
    border-right: 0;
  }
  .border-b-0{
    border-bottom: 0;
  }
  .redText{
    color: red;
    font-size: 12px;
    font-weight: 500;
    padding: 5px;
  }

  .tooltip {
  position: relative;
  display: inline-block;
  border-bottom: 1px dotted black;
}

.tooltip .tooltiptext {
  visibility: hidden;
  width: 350px;
  /* background-color: #555;
  color: #fff; */
  text-align: center;
  /* border-radius: 6px; */
  padding: 5px 0;
  position: absolute;
  z-index: 1;
  bottom: 125%;
  left: 50%;
  margin-left: -60px;
  opacity: 0;
  transition: opacity 0.3s;
  background: #FAFAFA;
  box-shadow: 0px 19px 38px rgba(0, 0, 0, 0.3), 0px 15px 12px rgba(0, 0, 0, 0.22);
  border-radius: 2px;
}

.tooltip .tooltiptext::after {
  content: "";
  position: absolute;
  top: 100%;
  left: 50%;
  margin-left: -5px;
  border-width: 5px;
  border-style: solid;
  border-color: #555 transparent transparent transparent;
}

.tooltip:hover .tooltiptext {
  visibility: visible;
  opacity: 1;
}

</style>